﻿// CodeGear C++Builder
// Copyright (c) 1995, 2022 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylPowerManager.pas' rev: 35.00 (Windows)

#ifndef ZylpowermanagerHPP
#define ZylpowermanagerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Samples.Gauges.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.Graphics.hpp>
#include <System.UITypes.hpp>

//-- user supplied -----------------------------------------------------------

namespace Zylpowermanager
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TZylPowerManager;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TBatteryStatus : unsigned char { bsHigh, bsLow, bsCritical, bsCharging, bsNoBattery, bsUnknown };

typedef System::Set<TBatteryStatus, TBatteryStatus::bsHigh, TBatteryStatus::bsUnknown> TBatteryStatusSet;

enum DECLSPEC_DENUM TACLineStatus : unsigned char { acsOffline, acsOnline, acsUnknown };

typedef void __fastcall (__closure *TOEMEvent)(System::TObject* Sender, int EventCode);

typedef void __fastcall (__closure *TQuerySuspendEvent)(System::TObject* Sender, bool &CanSuspend);

enum DECLSPEC_DENUM TWindowsVersion : unsigned char { wvUnknown, wvWin95, wvWin95OSR2, wvWin98, wvWin98SE, wvWinME, wvWinNT31, wvWinNT35, wvWinNT351, wvWinNT4, wvWin2000, wvWinXP, wvWin2003, wvWinVista, wvWin2008, wvWin7, wvWin8, wvWin81, wvWin10 };

typedef void __fastcall (__closure *TACLineStatusChangeEvent)(System::TObject* Sender, TACLineStatus NewACLineStatus);

class PASCALIMPLEMENTATION TZylPowerManager : public Vcl::Samples::Gauges::TGauge
{
	typedef Vcl::Samples::Gauges::TGauge inherited;
	
private:
	double FVersion;
	bool FActive;
	unsigned FUpdateInterval;
	HWND FWindowHandle;
	Vcl::Extctrls::TTimer* FTimer;
	System::Uitypes::TColor FCriticalColor;
	System::Uitypes::TColor FLowColor;
	System::Uitypes::TColor FHighColor;
	System::Uitypes::TColor FNoBatteryColor;
	System::Uitypes::TColor FChargingColor;
	bool FShowCharging;
	TACLineStatus FACLineStatus;
	TQuerySuspendEvent FOnQuerySuspend;
	TQuerySuspendEvent FOnQueryStandby;
	System::Classes::TNotifyEvent FOnQuerySuspendFailed;
	System::Classes::TNotifyEvent FOnQueryStandbyFailed;
	System::Classes::TNotifyEvent FOnSuspend;
	System::Classes::TNotifyEvent FOnStandby;
	System::Classes::TNotifyEvent FOnResumeCritical;
	System::Classes::TNotifyEvent FOnResumeSuspend;
	System::Classes::TNotifyEvent FOnResumeStandby;
	System::Classes::TNotifyEvent FOnResumeFromFailure;
	System::Classes::TNotifyEvent FOnBatteryLow;
	System::Classes::TNotifyEvent FOnPowerStatusChange;
	TOEMEvent FOnOEMEvent;
	System::Classes::TNotifyEvent FOnResumeAutomatic;
	TACLineStatusChangeEvent FOnACLineStatusChange;
	System::UnicodeString FLockKey;
	System::UnicodeString FUnlockKey;
	void __fastcall SetUpdateInterval(const unsigned value);
	void __fastcall DoTimer(System::TObject* Sender);
	bool __fastcall SetPrivilege(System::UnicodeString sPrivilegeName, bool bEnabled);
	bool __fastcall LockWorkStationEx();
	bool __fastcall RunningInTheIDE();
	bool __fastcall IsRegistered();
	void __fastcall CheckRegistered();
	System::UnicodeString __fastcall DecryptString(const System::AnsiString str);
	int __fastcall GetChecksum(const System::AnsiString str);
	
protected:
	MESSAGE void __fastcall WMPowerBroadcast(Winapi::Messages::TMessage &Msg);
	bool __fastcall IsEnabled();
	System::Uitypes::TColor __fastcall GetForeColor();
	int __fastcall GetMinValue();
	int __fastcall GetMaxValue();
	int __fastcall GetProgress();
	TWindowsVersion __fastcall GetWindowsVersion();
	
public:
	__property System::UnicodeString UnlockKey = {read=FUnlockKey, write=FUnlockKey};
	__property double Version = {read=FVersion};
	__fastcall virtual TZylPowerManager(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TZylPowerManager();
	void __fastcall UpdateBattery();
	TBatteryStatusSet __fastcall GetBatteryStatus();
	TACLineStatus __fastcall GetACLineStatus();
	unsigned __fastcall GetBatteryLifeTime();
	unsigned __fastcall GetBatteryFullLifeTime();
	unsigned __fastcall GetBatteryLifePercent();
	bool __fastcall HasBattery();
	bool __fastcall Standby(bool Force = true);
	bool __fastcall Hibernate(bool Force = true);
	bool __fastcall TurnOff(bool Force);
	bool __fastcall Reboot(bool Force = true);
	bool __fastcall LogOff(bool Force = true);
	bool __fastcall LockComputer();
	void __fastcall TurnOffMonitor();
	void __fastcall ScreenSaver();
	void __fastcall EnableHibernation();
	
__published:
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property unsigned UpdateInterval = {read=FUpdateInterval, write=SetUpdateInterval, default=800};
	__property System::Uitypes::TColor CriticalColor = {read=FCriticalColor, write=FCriticalColor, default=255};
	__property System::Uitypes::TColor LowColor = {read=FLowColor, write=FLowColor, default=65535};
	__property System::Uitypes::TColor HighColor = {read=FHighColor, write=FHighColor, default=32768};
	__property System::Uitypes::TColor NoBatteryColor = {read=FNoBatteryColor, write=FNoBatteryColor, default=16777215};
	__property System::Uitypes::TColor ChargingColor = {read=FChargingColor, write=FChargingColor, default=255};
	__property bool ShowCharging = {read=FShowCharging, write=FShowCharging, default=1};
	__property bool Enabled = {read=IsEnabled, nodefault};
	__property System::Uitypes::TColor ForeColor = {read=GetForeColor, nodefault};
	__property int MinValue = {read=GetMinValue, nodefault};
	__property int MaxValue = {read=GetMaxValue, nodefault};
	__property int Progress = {read=GetProgress, nodefault};
	__property TQuerySuspendEvent OnQuerySuspend = {read=FOnQuerySuspend, write=FOnQuerySuspend};
	__property TQuerySuspendEvent OnQueryStandby = {read=FOnQueryStandby, write=FOnQueryStandby};
	__property System::Classes::TNotifyEvent OnQuerySuspendFailed = {read=FOnQuerySuspendFailed, write=FOnQuerySuspendFailed};
	__property System::Classes::TNotifyEvent OnQueryStandbyFailed = {read=FOnQueryStandbyFailed, write=FOnQueryStandbyFailed};
	__property System::Classes::TNotifyEvent OnSuspend = {read=FOnSuspend, write=FOnSuspend};
	__property System::Classes::TNotifyEvent OnStandby = {read=FOnStandby, write=FOnStandby};
	__property System::Classes::TNotifyEvent OnResumeCritical = {read=FOnResumeCritical, write=FOnResumeCritical};
	__property System::Classes::TNotifyEvent OnResumeSuspend = {read=FOnResumeSuspend, write=FOnResumeSuspend};
	__property System::Classes::TNotifyEvent OnResumeStandby = {read=FOnResumeStandby, write=FOnResumeStandby};
	__property System::Classes::TNotifyEvent OnResumeFromFailure = {read=FOnResumeFromFailure, write=FOnResumeFromFailure};
	__property System::Classes::TNotifyEvent OnBatteryLow = {read=FOnBatteryLow, write=FOnBatteryLow};
	__property System::Classes::TNotifyEvent OnPowerStatusChange = {read=FOnPowerStatusChange, write=FOnPowerStatusChange};
	__property TOEMEvent OnOEMEvent = {read=FOnOEMEvent, write=FOnOEMEvent};
	__property System::Classes::TNotifyEvent OnResumeAutomatic = {read=FOnResumeAutomatic, write=FOnResumeAutomatic};
	__property TACLineStatusChangeEvent OnACLineStatusChange = {read=FOnACLineStatusChange, write=FOnACLineStatusChange};
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE void __fastcall Register();
}	/* namespace Zylpowermanager */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_ZYLPOWERMANAGER)
using namespace Zylpowermanager;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylpowermanagerHPP
