unit FDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Gauges, ExtCtrls, StdCtrls, ZylPowerManager;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    ZylPowerManager1: TZylPowerManager;
    btnShutDown: TButton;
    btnRestart: TButton;
    btnLogOff: TButton;
    btnLock: TButton;
    btnTurnOffMonitor: TButton;
    btnScreenSaver: TButton;
    btnStandby: TButton;
    btnHibernate: TButton;
    memoOutput: TMemo;
    procedure Timer1Timer(Sender: TObject);
    procedure btnShutDownClick(Sender: TObject);
    procedure btnRestartClick(Sender: TObject);
    procedure btnLogOffClick(Sender: TObject);
    procedure btnLockClick(Sender: TObject);
    procedure btnTurnOffMonitorClick(Sender: TObject);
    procedure btnScreenSaverClick(Sender: TObject);
    procedure btnStandbyClick(Sender: TObject);
    procedure btnHibernateClick(Sender: TObject);
    procedure ZylPowerManager1ACLineStatusChange(Sender: TObject;
      NewACLineStatus: TACLineStatus);
    procedure ZylPowerManager1BatteryLow(Sender: TObject);
    procedure ZylPowerManager1ResumeAutomatic(Sender: TObject);
    procedure ZylPowerManager1ResumeFromFailure(Sender: TObject);
    procedure ZylPowerManager1ResumeStandby(Sender: TObject);
    procedure ZylPowerManager1ResumeSuspend(Sender: TObject);
    procedure ZylPowerManager1Standby(Sender: TObject);
    procedure ZylPowerManager1Suspend(Sender: TObject);
    procedure ZylPowerManager1ResumeCritical(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Timer1Timer(Sender: TObject);
var
  strMsg: String;
begin
  strMsg := '';
  if bsHigh in ZylPowerManager1.GetBatteryStatus then
  begin
    strMsg := strMsg + ' High';
  end;
  if bsLow in ZylPowerManager1.GetBatteryStatus then
  begin
    strMsg := strMsg + ' Low';
  end;
  if bsCritical in ZylPowerManager1.GetBatteryStatus then
  begin;
    strMsg := strMsg + ' Critical';
  end;
  if bsCharging in ZylPowerManager1.GetBatteryStatus  then
  begin
    strMsg := strMsg + ' Charging';
  end;
  if bsNoBattery in ZylPowerManager1.GetBatteryStatus  then
  begin
    strMsg := strMsg + ' No battery';
  end;
  if bsUnknown in ZylPowerManager1.GetBatteryStatus then
  begin
    strMsg := strMsg + ' Unkown';
  end;
  label1.Caption := 'Status:' + strMsg;
end;

procedure TForm1.btnShutDownClick(Sender: TObject);
begin
  ZylPowerManager1.TurnOff(true);
end;

procedure TForm1.btnRestartClick(Sender: TObject);
begin
  ZylPowerManager1.Reboot(True);
end;

procedure TForm1.btnLogOffClick(Sender: TObject);
begin
  ZylPowerManager1.LogOff(true);
end;

procedure TForm1.btnLockClick(Sender: TObject);
begin
  ZylPowerManager1.LockComputer();
end;

procedure TForm1.btnTurnOffMonitorClick(Sender: TObject);
begin
  ZylPowerManager1.TurnOffMonitor();
end;

procedure TForm1.btnScreenSaverClick(Sender: TObject);
begin
  ZylPowerManager1.ScreenSaver();
end;

procedure TForm1.btnStandbyClick(Sender: TObject);
begin
  ZylPowerManager1.Standby(True);
end;

procedure TForm1.btnHibernateClick(Sender: TObject);
begin
  ZylPowerManager1.Hibernate();
end;

procedure TForm1.ZylPowerManager1ACLineStatusChange(Sender: TObject;
  NewACLineStatus: TACLineStatus);
begin
  if NewACLineStatus = acsOffline then
    memoOutput.Lines.Add('Power Off')
  else if NewACLineStatus = acsOnline then
    memoOutput.Lines.Add('Power On');
end;

procedure TForm1.ZylPowerManager1BatteryLow(Sender: TObject);
begin
  memoOutput.Lines.Add('Battery low!');
end;

procedure TForm1.ZylPowerManager1ResumeAutomatic(Sender: TObject);
begin
  memoOutput.Lines.Add('Resume automatically!');
end;

procedure TForm1.ZylPowerManager1ResumeFromFailure(Sender: TObject);
begin
  memoOutput.Lines.Add('Resume from failure!');
end;

procedure TForm1.ZylPowerManager1ResumeStandby(Sender: TObject);
begin
  memoOutput.Lines.Add('Resume from standby!');
end;

procedure TForm1.ZylPowerManager1ResumeSuspend(Sender: TObject);
begin
  memoOutput.Lines.Add('Resume from hibernation!');
end;

procedure TForm1.ZylPowerManager1Standby(Sender: TObject);
begin
  memoOutput.Lines.Add('Standby!');
end;

procedure TForm1.ZylPowerManager1Suspend(Sender: TObject);
begin
  memoOutput.Lines.Add('Hibernate!');
end;

procedure TForm1.ZylPowerManager1ResumeCritical(Sender: TObject);
begin
  memoOutput.Lines.Add('Resume critical!');
end;

end.
