// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Zylbattery.pas' rev: 21.00

#ifndef ZylbatteryHPP
#define ZylbatteryHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Gauges.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zylbattery
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TBatteryStatus { bsHigh, bsLow, bsCritical, bsCharging, bsNoBattery, bsUnknown };
#pragma option pop

typedef Set<TBatteryStatus, bsHigh, bsUnknown>  TBatteryStatusSet;

#pragma option push -b-
enum TACLineStatus { acsOffline, acsOnline, acsUnknown };
#pragma option pop

typedef void __fastcall (__closure *TOEMEvent)(System::TObject* Sender, int EventCode);

typedef void __fastcall (__closure *TQuerySuspendEvent)(System::TObject* Sender, bool &CanSuspend);

#pragma option push -b-
enum TWindowsVersion { wvUnknown, wvWin95, wvWin95OSR2, wvWin98, wvWin98SE, wvWinME, wvWinNT31, wvWinNT35, wvWinNT351, wvWinNT4, wvWin2000, wvWinXP, wvWin2003, wvWinVista, wvWin2008, wvWin7, wvWin8, wvWin81, wvWin10 };
#pragma option pop

typedef void __fastcall (__closure *TACLineStatusChangeEvent)(System::TObject* Sender, TACLineStatus NewACLineStatus);

class DELPHICLASS TZylBattery;
class PASCALIMPLEMENTATION TZylBattery : public Gauges::TGauge
{
	typedef Gauges::TGauge inherited;
	
private:
	bool FRegistered;
	double FVersion;
	bool FActive;
	unsigned FUpdateInterval;
	HWND FWindowHandle;
	Extctrls::TTimer* FTimer;
	Graphics::TColor FCriticalColor;
	Graphics::TColor FLowColor;
	Graphics::TColor FHighColor;
	Graphics::TColor FNoBatteryColor;
	Graphics::TColor FChargingColor;
	bool FShowCharging;
	TACLineStatus FACLineStatus;
	TQuerySuspendEvent FOnQuerySuspend;
	TQuerySuspendEvent FOnQueryStandby;
	Classes::TNotifyEvent FOnQuerySuspendFailed;
	Classes::TNotifyEvent FOnQueryStandbyFailed;
	Classes::TNotifyEvent FOnSuspend;
	Classes::TNotifyEvent FOnStandby;
	Classes::TNotifyEvent FOnResumeCritical;
	Classes::TNotifyEvent FOnResumeSuspend;
	Classes::TNotifyEvent FOnResumeStandby;
	Classes::TNotifyEvent FOnResumeFromFailure;
	Classes::TNotifyEvent FOnBatteryLow;
	Classes::TNotifyEvent FOnPowerStatusChange;
	TOEMEvent FOnOEMEvent;
	Classes::TNotifyEvent FOnResumeAutomatic;
	TACLineStatusChangeEvent FOnACLineStatusChange;
	void __fastcall SetUpdateInterval(const unsigned value);
	void __fastcall DoTimer(System::TObject* Sender);
	bool __fastcall SetPrivilege(System::UnicodeString sPrivilegeName, bool bEnabled);
	bool __fastcall RunningInTheIDE(void);
	void __fastcall DoRegistrationCheck(void);
	
protected:
	MESSAGE void __fastcall WMPowerBroadcast(Messages::TMessage &Msg);
	bool __fastcall IsEnabled(void);
	Graphics::TColor __fastcall GetForeColor(void);
	int __fastcall GetMinValue(void);
	int __fastcall GetMaxValue(void);
	int __fastcall GetProgress(void);
	TWindowsVersion __fastcall GetWindowsVersion(void);
	
public:
	__property double Version = {read=FVersion};
	__fastcall virtual TZylBattery(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylBattery(void);
	void __fastcall UpdateBattery(void);
	TBatteryStatusSet __fastcall GetBatteryStatus(void);
	TACLineStatus __fastcall GetACLineStatus(void);
	unsigned __fastcall GetBatteryLifeTime(void);
	unsigned __fastcall GetBatteryFullLifeTime(void);
	unsigned __fastcall GetBatteryLifePercent(void);
	bool __fastcall HasBattery(void);
	void __fastcall Standby(bool Force = true);
	void __fastcall Hibernate(bool Force = true);
	void __fastcall TurnOff(bool Force = true);
	void __fastcall Reboot(bool Force = true);
	void __fastcall LogOff(bool Force = true);
	void __fastcall TurnOffMonitor(void);
	void __fastcall ScreenSaver(void);
	void __fastcall EnableHibernation(void);
	
__published:
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property unsigned UpdateInterval = {read=FUpdateInterval, write=SetUpdateInterval, default=800};
	__property Graphics::TColor CriticalColor = {read=FCriticalColor, write=FCriticalColor, default=255};
	__property Graphics::TColor LowColor = {read=FLowColor, write=FLowColor, default=65535};
	__property Graphics::TColor HighColor = {read=FHighColor, write=FHighColor, default=32768};
	__property Graphics::TColor NoBatteryColor = {read=FNoBatteryColor, write=FNoBatteryColor, default=16777215};
	__property Graphics::TColor ChargingColor = {read=FChargingColor, write=FChargingColor, default=255};
	__property bool ShowCharging = {read=FShowCharging, write=FShowCharging, default=1};
	__property bool Enabled = {read=IsEnabled, nodefault};
	__property Graphics::TColor ForeColor = {read=GetForeColor, nodefault};
	__property int MinValue = {read=GetMinValue, nodefault};
	__property int MaxValue = {read=GetMaxValue, nodefault};
	__property int Progress = {read=GetProgress, nodefault};
	__property TQuerySuspendEvent OnQuerySuspend = {read=FOnQuerySuspend, write=FOnQuerySuspend};
	__property TQuerySuspendEvent OnQueryStandby = {read=FOnQueryStandby, write=FOnQueryStandby};
	__property Classes::TNotifyEvent OnQuerySuspendFailed = {read=FOnQuerySuspendFailed, write=FOnQuerySuspendFailed};
	__property Classes::TNotifyEvent OnQueryStandbyFailed = {read=FOnQueryStandbyFailed, write=FOnQueryStandbyFailed};
	__property Classes::TNotifyEvent OnSuspend = {read=FOnSuspend, write=FOnSuspend};
	__property Classes::TNotifyEvent OnStandby = {read=FOnStandby, write=FOnStandby};
	__property Classes::TNotifyEvent OnResumeCritical = {read=FOnResumeCritical, write=FOnResumeCritical};
	__property Classes::TNotifyEvent OnResumeSuspend = {read=FOnResumeSuspend, write=FOnResumeSuspend};
	__property Classes::TNotifyEvent OnResumeStandby = {read=FOnResumeStandby, write=FOnResumeStandby};
	__property Classes::TNotifyEvent OnResumeFromFailure = {read=FOnResumeFromFailure, write=FOnResumeFromFailure};
	__property Classes::TNotifyEvent OnBatteryLow = {read=FOnBatteryLow, write=FOnBatteryLow};
	__property Classes::TNotifyEvent OnPowerStatusChange = {read=FOnPowerStatusChange, write=FOnPowerStatusChange};
	__property TOEMEvent OnOEMEvent = {read=FOnOEMEvent, write=FOnOEMEvent};
	__property Classes::TNotifyEvent OnResumeAutomatic = {read=FOnResumeAutomatic, write=FOnResumeAutomatic};
	__property TACLineStatusChangeEvent OnACLineStatusChange = {read=FOnACLineStatusChange, write=FOnACLineStatusChange};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Zylbattery */
using namespace Zylbattery;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylbatteryHPP
